// Variables that are used on both client and server

if ( CLIENT ) then
 
  SWEP.PrintName = "Creepernade";
   SWEP.Slot = 1;
   SWEP.SlotPos = 1;
   SWEP.DrawAmmo = true;
   SWEP.DrawCrosshair = false;
   SWEP.Category = "Chris's SWEPs"
   SWEP.Author = "Chris";
   SWEP.Contact = "Cheesecake Servers";
   SWEP.Purpose = "";
   SWEP.Instructions = "Ssssay, that's a nice contraption you have there. {Warning! These are heavy and will drop closeby!}"
     SWEP.WepSelectIcon        = surface.GetTextureID("vgui/entities/weapon_creepernade")
    killicon.AddFont( "weapon_deagle", "CSKillIcons", SWEP.IconLetter, Color( 255, 80, 0, 255 ) )
     
    // Generated VElements and WElements tables go here:
   SWEP.VElements = {
	["some_unique_name"] = { type = "Model", model = "models/MCModelPack/mobs/creeper.mdl", bone = "v_weapon.Flashbang_Parent", pos = Vector(0.305, -3.527, -0.67), angle = Angle(-116.756, 0, 90), size = Vector(0.078, 0.078, 0.078), color = Color(255, 255, 255, 255), surpresslightning = false, material = "", skin = 0, bodygroup = {} }
}
  SWEP.WElements = {
	["some_unique_name"] = { type = "Model", model = "models/MCModelPack/mobs/creeper.mdl", pos = Vector(1.368, 2.789, 2.987), angle = Angle(-158.431, 42.312, 6.556), size = Vector(0.172, 0.172, 0.172), color = Color(255, 255, 255, 255), surpresslightning = false, material = "", skin = 0, bodygroup = {} }
}
     
end

SWEP.Base 				= "weapon_mad_base"

SWEP.HoldType = "grenade"
SWEP.ViewModelFOV = 70
SWEP.ViewModelFlip = true
SWEP.ViewModel = "models/weapons/v_eq_fraggrenade.mdl"
SWEP.WorldModel = "models/weapons/w_pistol.mdl"
SWEP.ShowViewModel = true
SWEP.ShowWorldModel = false
SWEP.ViewModelBonescales = {["v_weapon.Flashbang_Parent"] = Vector(0.009, 0.009, 0.009)}

SWEP.Spawnable			= false
SWEP.AdminSpawnable		= true

SWEP.Primary.Recoil		= 5
SWEP.Primary.Damage		= 0
SWEP.Primary.NumShots		= 0
SWEP.Primary.Cone			= 0.075
SWEP.Primary.Delay 		= 1.5

SWEP.Primary.ClipSize		= -1					// Size of a clip
SWEP.Primary.DefaultClip	= 1					// Default number of bullets in a clip
SWEP.Primary.Automatic		= false				// Automatic/Semi Auto
SWEP.Primary.Ammo			= "Grenade"

SWEP.Secondary.ClipSize		= -1					// Size of a clip
SWEP.Secondary.DefaultClip	= -1					// Default number of bullets in a clip
SWEP.Secondary.Automatic	= false				// Automatic/Semi Auto
SWEP.Secondary.Ammo		= "none"

SWEP.ShellEffect			= "none"				// "effect_mad_shell_pistol" or "effect_mad_shell_rifle" or "effect_mad_shell_shotgun"
SWEP.ShellDelay			= 0

SWEP.Pistol				= true
SWEP.Rifle				= false
SWEP.Shotgun			= false
SWEP.Sniper				= false

SWEP.GrenadeType			= "ent_creepernade"
SWEP.GrenadeName			= "weapon_creepernade"
SWEP.GrenadeTime			= "2.5"
SWEP.CookGrenade			= true

/*---------------------------------------------------------
   Name: SWEP:PrimaryAttack()
   Desc: +attack1 has been pressed.
---------------------------------------------------------*/
function SWEP:PrimaryAttack()

	// Holst/Deploy your fucking weapon
	if (not self.Owner:IsNPC() and self.Owner:KeyDown(IN_USE)) then
		bHolsted = !self.Weapon:GetDTBool(0)
		self:SetHolsted(bHolsted)

		self.Weapon:SetNextPrimaryFire(CurTime() + 0.3)
		self.Weapon:SetNextSecondaryFire(CurTime() + 0.3)

		self:SetIronsights(false)

		return
	end

	if (self.Owner:GetNetworkedInt("Throw") > CurTime() or self.Owner:GetAmmoCount(self.Primary.Ammo) <= 0 or self.Owner:GetNetworkedInt("Primed") != 0 or self.Weapon:GetNetworkedBool("Holsted")) then return end

	self.Weapon:SendWeaponAnim(ACT_VM_PULLPIN)

	self.Owner:SetNetworkedInt("Primed", 1)
	self.Owner:SetNetworkedInt("Throw", CurTime() + 1)
	self.Owner:SetNetworkedBool("Cooked", false)
end

/*---------------------------------------------------------
   Name: SWEP:SecondaryAttack()
   Desc: +attack2 has been pressed.
---------------------------------------------------------*/
function SWEP:SecondaryAttack()

	// I used the cooking script of Wizey as an example.
	if not self.CookGrenade then return end
	if self.Owner:GetNetworkedBool("Reloading") then return end
	if self.Owner:GetNetworkedInt("Primed") == 0 then return end
	if self.Owner:GetNetworkedInt("Primed") == 2 then return end

	self.Owner:SetNetworkedBool("Reloading", true)
	timer.Simple(self.GrenadeTime + 0.1, function() if not self.Owner then return end self.Owner:SetNetworkedBool("Reloading", false) end)

	self.Weapon:EmitSound("weapons/creepernade/fuse.wav", 60)

	self.Owner:SetNetworkedBool("Cooked", true)
	self.NextExplode = CurTime() + self.GrenadeTime

	timer.Simple(self.GrenadeTime, function()
		if not self.Owner then return end 	
		if  not IsFirstTimePredicted() then return end

		if self.Owner:GetNetworkedBool("Cooked") and self.Weapon:GetOwner():GetActiveWeapon():GetClass() == self.GrenadeName and self.Owner:Alive() then
			if self.Owner:GetNetworkedInt("Primed") == 1 then
				local grenade = ents.Create(self.GrenadeType)

				local pos = self.Owner:GetShootPos()
					pos = pos + self.Owner:GetForward() * 1
					pos = pos + self.Owner:GetRight() * 7
	
					if self.Owner:KeyDown(IN_SPEED) then
						pos = pos + self.Owner:GetUp() * -4
					else
						pos = pos + self.Owner:GetUp() * 1
					end

				grenade:SetPos(pos)

				grenade:SetAngles(Vector(math.random(1, 100), math.random(1, 100), math.random(1, 100)))
				grenade:SetOwner(self.Owner)
				grenade:SetNetworkedInt("Cook", 0)
				grenade:Spawn()

				self.Owner:SetNetworkedInt("Primed", 0)
				self.Owner:SetNetworkedBool("Cooked", false)

				timer.Simple(0.6, function()
					if not self.Owner then return end

					if self.Owner:GetAmmoCount(self.Primary.Ammo) > 0 then
						self.Weapon:SendWeaponAnim(ACT_VM_DRAW)
						self.Owner:SetNetworkedInt("Primed", 0)
					else
						self.Owner:SetNetworkedInt("Primed", 0)
						self.Owner:ConCommand("lastinv")
					end
				end)
			end			
		end 
	end)
end

/*---------------------------------------------------------
   Name: SWEP:Think()
   Desc: Called every frame.
---------------------------------------------------------*/
function SWEP:Think()

	self:SecondThink()

	if (self.Owner:KeyDown(IN_SPEED) and self.Owner:GetNetworkedInt("Primed") == 0) or self.Weapon:GetNetworkedBool("Holsted") then
		if self.Rifle or self.Sniper or self.Shotgun then
			if (SERVER) then
				self:SetWeaponHoldType("passive")
			end
		elseif self.Pistol then
			if (SERVER) then
				self:SetWeaponHoldType("normal")
			end
		end
	else
		if (SERVER) then
			self:SetWeaponHoldType(self.HoldType)
		end
	end

	if (self.Owner:GetNetworkedInt("Primed") == 1 and not self.Owner:KeyDown(IN_ATTACK)) then
		if self.Owner:GetNetworkedInt("Throw") < CurTime() then
			self.Owner:SetNetworkedInt("Primed", 2)
			self.Owner:SetNetworkedInt("Throw", CurTime() + 1.5)

			if not self.Owner:Crouching() then
				self.Weapon:SendWeaponAnim(ACT_VM_THROW)
			end

			self.Owner:SetAnimation(PLAYER_ATTACK1)

			timer.Simple(0.35, function()	if not self.Owner then return end self:ThrowGrenade() self.Owner:ViewPunch(Vector(math.Rand(1, 2), math.Rand(0, 0), math.Rand(0, 0))) end)
		end
	end

	if self.Owner:GetNetworkedBool("Cooked") and self.Owner:GetNetworkedBool("LastShootCook") < CurTime() then
		if ((SinglePlayer() and SERVER) or CLIENT) then
			self.Weapon:SetNetworkedFloat("LastShootTime", CurTime())
			self.Owner:EmitSound("NPC_CombineCamera.Click")
		end

		self.Owner:SetNetworkedBool("LastShootCook", CurTime() + 1)
	end
end

/*---------------------------------------------------------
   Name: SWEP:Holster()
   Desc: Weapon wants to holster.
	   Return true to allow the weapon to holster.
---------------------------------------------------------*/
function SWEP:Holster()

	self.Owner:SetNetworkedInt("Primed", 0)
	self.Owner:SetNetworkedInt("Throw", CurTime())

	return true
end

/*---------------------------------------------------------
   Name: SWEP:Deploy()
   Desc: Whip it out.
---------------------------------------------------------*/
function SWEP:Deploy()

	self.Weapon:SendWeaponAnim(ACT_VM_DRAW)

	self.Weapon:SetNextPrimaryFire(CurTime() + self.DeployDelay)
	self.Weapon:SetNextSecondaryFire(CurTime() + self.DeployDelay)
	self.ActionDelay 	= (CurTime() + self.DeployDelay)
	self.Owner:SetNetworkedInt("Throw", CurTime() + self.DeployDelay)

	self.Owner:SetNetworkedBool("LastShootCook", CurTime())

	return true
end

/*---------------------------------------------------------
   Name: SWEP:ThrowGrenade()
---------------------------------------------------------*/
function SWEP:ThrowGrenade()

	if (self.Owner:GetNetworkedInt("Primed") != 2 or CLIENT) then return end

	if self.CookGrenade and not self.Owner:GetNetworkedBool("Cooked") then
		self.NextExplode = CurTime() + self.GrenadeTime
		self.Weapon:EmitSound("weapons/creepernade/fuse.wav", 60)
	end

	local grenade = ents.Create(self.GrenadeType)

	if self.CookGrenade then
		self.Owner:SetNetworkedBool("Cooked", false)

		local RemainingTime = self.NextExplode - CurTime()
		grenade:SetNetworkedInt("Cook", CurTime() + RemainingTime)
	end

	local pos = self.Owner:GetShootPos()
		pos = pos + self.Owner:GetRight() * 7

		if self.Owner:KeyDown(IN_SPEED) and not self.Owner:Crouching() then
			pos = pos + self.Owner:GetUp() * -4
		elseif not self.Owner:Crouching() then
			pos = pos + self.Owner:GetForward() * -6
			pos = pos + self.Owner:GetUp() * 1
		else
			pos = pos + self.Owner:GetForward() * 1
			pos = pos + self.Owner:GetUp() * -24
		end

	grenade:SetPos(pos)
	grenade:SetAngles(Vector(math.random(1, 100), math.random(1, 100), math.random(1, 100)))
	grenade:SetOwner(self.Owner)
	grenade:Spawn()

	local phys = grenade:GetPhysicsObject()

	if self.Owner:KeyDown(IN_FORWARD) then
		self.Force = 3200
	elseif self.Owner:KeyDown(IN_BACK) then
		self.Force = 2100
	else
		self.Force = 2500
	end

	if not self.Owner:Crouching() then
		phys:ApplyForceCenter(self.Owner:GetAimVector() * self.Force * 1.2 + Vector(0, 0, 200))
	else
		phys:ApplyForceCenter(self.Owner:GetAimVector() * self.Force * 1.2 + Vector(0, 0, 0))
	end

	phys:AddAngleVelocity(Vector(math.random(-500, 500), math.random(-500, 500), math.random(-500, 500)))

	self.Owner:RemoveAmmo(1, self.Primary.Ammo)

	timer.Simple(0.6, function()
		if not self.Owner then return end

		if self.Owner:GetAmmoCount(self.Primary.Ammo) > 0 then
			self.Weapon:SendWeaponAnim(ACT_VM_DRAW)
			self.Owner:SetNetworkedInt("Primed", 0)
		else
			self.Owner:SetNetworkedInt("Primed", 0)
//			self.Weapon:Remove()
			self.Owner:ConCommand("lastinv")
		end
	end)
end




function SWEP:Initialize()
 
    self:SetWeaponHoldType( self.HoldType )
 
    if CLIENT then
     
        self:CreateModels(self.VElements) // create viewmodels
        self:CreateModels(self.WElements) // create worldmodels
         
        // init view model bone build function
        self.BuildViewModelBones = function( s )
            if LocalPlayer():GetActiveWeapon() == self and self.ViewModelBonescales then
                for k, v in pairs( self.ViewModelBonescales ) do
                    local bone = s:LookupBone(k)
                    if (!bone) then continue end
                    local m = s:GetBoneMatrix(bone)
                    if (!m) then continue end
                    m:Scale(v)
                    s:SetBoneMatrix(bone, m)
                end
            end
        end
         
    end
 
end
 
 
function SWEP:OnRemove()
     

     
    if CLIENT then
        self:RemoveModels()
    end
     
end
     
 
if CLIENT then
 
    SWEP.vRenderOrder = nil
    function SWEP:ViewModelDrawn()
         
        local vm = self.Owner:GetViewModel()
        if !ValidEntity(vm) then return end
         
        if (!self.VElements) then return end
         
        if vm.BuildBonePositions ~= self.BuildViewModelBones then
            vm.BuildBonePositions = self.BuildViewModelBones
        end
 
        if (self.ShowViewModel == nil or self.ShowViewModel) then
            vm:SetColor(255,255,255,255)
        else
            // we set the alpha to 1 instead of 0 because else ViewModelDrawn stops being called
            vm:SetColor(255,255,255,1)
        end
         
        if (!self.vRenderOrder) then
             
            // we build a render order because sprites need to be drawn after models
            self.vRenderOrder = {}
 
            for k, v in pairs( self.VElements ) do
                if (v.type == "Model") then
                    table.insert(self.vRenderOrder, 1, k)
                elseif (v.type == "Sprite" or v.type == "Quad") then
                    table.insert(self.vRenderOrder, k)
                end
            end
             
        end
 
        for k, name in ipairs( self.vRenderOrder ) do
         
            local v = self.VElements[name]
            if (!v) then self.vRenderOrder = nil break end
         
            local model = v.modelEnt
            local sprite = v.spriteMaterial
             
            if (!v.bone) then continue end
            local bone = vm:LookupBone(v.bone)
            if (!bone) then continue end
             
            local pos, ang = Vector(0,0,0), Angle(0,0,0)
            local m = vm:GetBoneMatrix(bone)
            if (m) then
                pos, ang = m:GetTranslation(), m:GetAngle()
            end
             
            if (self.ViewModelFlip) then
                ang.r = -ang.r // Fixes mirrored models
            end
             
            if (v.type == "Model" and ValidEntity(model)) then
 
                model:SetPos(pos + ang:Forward() * v.pos.x + ang:Right() * v.pos.y + ang:Up() * v.pos.z )
                ang:RotateAroundAxis(ang:Up(), v.angle.y)
                ang:RotateAroundAxis(ang:Right(), v.angle.p)
                ang:RotateAroundAxis(ang:Forward(), v.angle.r)
 
                model:SetAngles(ang)
                model:SetModelScale(v.size)
                 
                if (v.material == "") then
                    model:SetMaterial("")
                elseif (model:GetMaterial() != v.material) then
                    model:SetMaterial( v.material )
                end
                 
                if (v.skin and v.skin != model:GetSkin()) then
                    model:SetSkin(v.skin)
                end
                 
                if (v.bodygroup) then
                    for k, v in pairs( v.bodygroup ) do
                        if (model:GetBodygroup(k) != v) then
                            model:SetBodygroup(k, v)
                        end
                    end
                end
                 
                if (v.surpresslightning) then
                    render.SuppressEngineLighting(true)
                end
                 
                render.SetColorModulation(v.color.r/255, v.color.g/255, v.color.b/255)
                render.SetBlend(v.color.a/255)
                model:DrawModel()
                render.SetBlend(1)
                render.SetColorModulation(1, 1, 1)
                 
                if (v.surpresslightning) then
                    render.SuppressEngineLighting(false)
                end
                 
            elseif (v.type == "Sprite" and sprite) then
                 
                local drawpos = pos + ang:Forward() * v.pos.x + ang:Right() * v.pos.y + ang:Up() * v.pos.z
                render.SetMaterial(sprite)
                render.DrawSprite(drawpos, v.size.x, v.size.y, v.color)
                 
            elseif (v.type == "Quad" and v.draw_func) then
                 
                local drawpos = pos + ang:Forward() * v.pos.x + ang:Right() * v.pos.y + ang:Up() * v.pos.z
                ang:RotateAroundAxis(ang:Up(), v.angle.y)
                ang:RotateAroundAxis(ang:Right(), v.angle.p)
                ang:RotateAroundAxis(ang:Forward(), v.angle.r)
                 
                cam.Start3D2D(drawpos, ang, v.size)
                    v.draw_func( self )
                cam.End3D2D()
 
            end
             
        end
         
    end
 
    SWEP.wRenderOrder = nil
    function SWEP:DrawWorldModel()
         
        if (self.ShowWorldModel == nil or self.ShowWorldModel) then
            self:DrawModel()
        end
         
        if (!self.WElements) then return end
         
        if (!self.wRenderOrder) then
 
            self.wRenderOrder = {}
 
            for k, v in pairs( self.WElements ) do
                if (v.type == "Model") then
                    table.insert(self.wRenderOrder, 1, k)
                elseif (v.type == "Sprite" or v.type == "Quad") then
                    table.insert(self.wRenderOrder, k)
                end
            end
 
        end
         
        local opos, oang = self:GetPos(), self:GetAngles()
        local bone_ent
 
        if (ValidEntity(self.Owner)) then
            bone_ent = self.Owner
        else
            // when the weapon is dropped
            bone_ent = self
        end
         
        local bone = bone_ent:LookupBone("ValveBiped.Bip01_R_Hand")
        if (bone) then
            local m = bone_ent:GetBoneMatrix(bone)
            if (m) then
                opos, oang = m:GetTranslation(), m:GetAngle()
            end
        end
         
        for k, name in pairs( self.wRenderOrder ) do
         
            local v = self.WElements[name]
            if (!v) then self.wRenderOrder = nil break end
         
            local model = v.modelEnt
            local sprite = v.spriteMaterial
 
            local pos, ang = Vector(opos.x, opos.y, opos.z), Angle(oang.p, oang.y, oang.r)
 
            if (v.type == "Model" and ValidEntity(model)) then
 
                model:SetPos(pos + ang:Forward() * v.pos.x + ang:Right() * v.pos.y + ang:Up() * v.pos.z )
                ang:RotateAroundAxis(ang:Up(), v.angle.y)
                ang:RotateAroundAxis(ang:Right(), v.angle.p)
                ang:RotateAroundAxis(ang:Forward(), v.angle.r)
 
                model:SetAngles(ang)
                model:SetModelScale(v.size)
                 
                if (v.material == "") then
                    model:SetMaterial("")
                elseif (model:GetMaterial() != v.material) then
                    model:SetMaterial( v.material )
                end
                 
                if (v.skin and v.skin != model:GetSkin()) then
                    model:SetSkin(v.skin)
                end
                 
                if (v.bodygroup) then
                    for k, v in pairs( v.bodygroup ) do
                        if (model:GetBodygroup(k) != v) then
                            model:SetBodygroup(k, v)
                        end
                    end
                end
                 
                if (v.surpresslightning) then
                    render.SuppressEngineLighting(true)
                end
                 
                render.SetColorModulation(v.color.r/255, v.color.g/255, v.color.b/255)
                render.SetBlend(v.color.a/255)
                model:DrawModel()
                render.SetBlend(1)
                render.SetColorModulation(1, 1, 1)
                 
                if (v.surpresslightning) then
                    render.SuppressEngineLighting(false)
                end
                 
            elseif (v.type == "Sprite" and sprite) then
                 
                local drawpos = pos + ang:Forward() * v.pos.x + ang:Right() * v.pos.y + ang:Up() * v.pos.z
                render.SetMaterial(sprite)
                render.DrawSprite(drawpos, v.size.x, v.size.y, v.color)
                 
            elseif (v.type == "Quad" and v.draw_func) then
                 
                local drawpos = pos + ang:Forward() * v.pos.x + ang:Right() * v.pos.y + ang:Up() * v.pos.z
                ang:RotateAroundAxis(ang:Up(), v.angle.y)
                ang:RotateAroundAxis(ang:Right(), v.angle.p)
                ang:RotateAroundAxis(ang:Forward(), v.angle.r)
                 
                cam.Start3D2D(drawpos, ang, v.size)
                    v.draw_func( self )
                cam.End3D2D()
 
            end
             
        end
         
    end
 
    function SWEP:CreateModels( tab )
 
        if (!tab) then return end
 
        // Create the clientside models here because Garry says we can't do it in the render hook
        for k, v in pairs( tab ) do
            if (v.type == "Model" and v.model and v.model != "" and (!ValidEntity(v.modelEnt) or v.createdModel != v.model) and
                    string.find(v.model, ".mdl") and file.Exists ("../"..v.model) ) then
                 
                v.modelEnt = ClientsideModel(v.model, RENDER_GROUP_VIEW_MODEL_OPAQUE)
                if (ValidEntity(v.modelEnt)) then
                    v.modelEnt:SetPos(self:GetPos())
                    v.modelEnt:SetAngles(self:GetAngles())
                    v.modelEnt:SetParent(self)
                    v.modelEnt:SetNoDraw(true)
                    v.createdModel = v.model
                else
                    v.modelEnt = nil
                end
                 
            elseif (v.type == "Sprite" and v.sprite and v.sprite != "" and (!v.spriteMaterial or v.createdSprite != v.sprite)
                and file.Exists ("../materials/"..v.sprite..".vmt")) then
                 
                local name = v.sprite.."-"
                local params = { ["$basetexture"] = v.sprite }
                // make sure we create a unique name based on the selected options
                local tocheck = { "nocull", "additive", "vertexalpha", "vertexcolor", "ignorez" }
                for i, j in pairs( tocheck ) do
                    if (v[j]) then
                        params["$"..j] = 1
                        name = name.."1"
                    else
                        name = name.."0"
                    end
                end
 
                v.createdSprite = v.sprite
                v.spriteMaterial = CreateMaterial(name,"UnlitGeneric",params)
                 
            end
        end
         
    end
 
    function SWEP:RemoveModels()
        if (self.VElements) then
            for k, v in pairs( self.VElements ) do
                if (ValidEntity( v.modelEnt )) then v.modelEnt:Remove() end
            end
        end
        if (self.WElements) then
            for k, v in pairs( self.WElements ) do
                if (ValidEntity( v.modelEnt )) then v.modelEnt:Remove() end
            end
        end
        self.VElements = nil
        self.WElements = nil
    end
 
end