// Variables that are used on both client and server
if (CLIENT) then
 
 
   SWEP.PrintName = "XEU-Alpha";
   SWEP.Slot = 1;
   SWEP.SlotPos = 1;
   SWEP.DrawAmmo = true;
   SWEP.DrawCrosshair = false;
   SWEP.Category = "Chris's SWEPs"
   SWEP.Author = "Chris";
   SWEP.Contact = "Cheesecake Servers";
   SWEP.Purpose = "WHAT IS THIS THING, SOME KIND OF SWORD?";
   SWEP.Instructions = "Because sometimes there just ain't enough gun."
   SWEP.WepSelectIcon        = surface.GetTextureID("vgui/entities/weapon_xeu")
   
end



SWEP.Base 				= "weapon_mad_base"

SWEP.ViewModel			= "models/weapons/v_q2blaster.mdl"
SWEP.WorldModel			= "models/weapons/w_q2blaster.mdl"
SWEP.ViewModelFOV	    = 45
SWEP.ViewModelFlip      = false


SWEP.Spawnable			= false
SWEP.AdminSpawnable		= true

function SWEP:Deploy()
	self.Owner:EmitSound( "weapons/gunslinger_draw.wav" ) ;
	return true;
end
function SWEP:Reload()
	if !( ( self.Weapon:Clip1() ) < ( self.Primary.ClipSize ) ) then return end
	self.Weapon:DefaultReload( ACT_VM_RELOAD )
	self:EmitSound( "buttons/button6.wav" )
end

SWEP.Primary.Sound 		= Sound("weapons/supergun/supergun-1.wav")
SWEP.Primary.Recoil		= 3.5
SWEP.Primary.Damage		= 10000
SWEP.Primary.Ignite     = true;
SWEP.Primary.Force      = 6500000;
SWEP.Primary.NumShots	= 4
SWEP.Primary.Cone		= 0.004
SWEP.Primary.Delay 		= 0.95

SWEP.Primary.ClipSize		= 650					// Size of a clip
SWEP.Primary.DefaultClip	= 860					// Default number of bullets in a clip
SWEP.Primary.Ammo			= "ar2"

SWEP.Pistol				= true
SWEP.Rifle				= false
SWEP.Shotgun			= false
SWEP.Sniper				= false

SWEP.RunArmOffset 		= Vector (1.7661, -3.2645, 1.9996)
SWEP.RunArmAngle	 		= Vector (-19.3086, 29.9962, 0)


SWEP.Type				= 3
SWEP.Mode				= true

SWEP.data 				= {}
SWEP.data.NormalMsg		= "LASERIFIC MODE ACTIVATED"
SWEP.data.ModeMsg			= "Switched to burst fire mode."
SWEP.data.Delay			= 0.4
SWEP.data.Cone			= 0.75
SWEP.data.Damage			= 70
SWEP.data.Recoil			= 3.5

SWEP.Penetration			= true
SWEP.MaxPenetration 		= 8
SWEP.MaxWoodPenetration 	= 16
SWEP.Ricochet			= true
SWEP.MaxRicochet			= 1



SWEP.IronSightsPos = Vector (-5.6674, -11.867, 2.505)
SWEP.IronSightsAng = Vector (0.1641, -0.983, 0.6437)
function SWEP:PrimaryAttack()
	// Make sure we can shoot first
	if ( !self:CanPrimaryAttack() ) then return end

	self.Weapon:EmitSound(Sound("weapons/supergun/supergun-1.wav"))
	self.Weapon:EmitSound(Sound("weapons/supergun/supergun-2.wav"))
	self:ShootBullet( 100, 1, 0 )

	// Remove 1 bullet from our clip
	self:TakePrimaryAmmo( 1 )

		local vShootPos = self.Owner:GetShootPos()
		local vShootAng = self.Owner:GetAimVector()
		
		
		local t = {}		

		t.caller  	= self.Owner	
		t.start   	= vShootPos	
		t.sang	 	= vShootAng	
		t.mreps	 	= 100		
		t.reps   	= 0 
		t.damage 	= 40
		t.length 	= 70
		t.filter 	= self.Owner		
		t.maxpens 	= 20
		t.pens	  	= 0
		t.powdeg  	= .01
		t.skew	  	= Vector( .05, .05, .05 )
		t.canbounce	= true
		t.bounceang	= .3
		t.bouncechance	= .4


	// Punch the player's view
	self.Owner:ViewPunch( Angle(-7,0,0 ) )
	self.Weapon:SetNextPrimaryFire( CurTime() + 0.95 )

	local trace = self.Owner:GetEyeTrace()
local effectdata = EffectData()
effectdata:SetOrigin( trace.HitPos )
effectdata:SetNormal( trace.HitNormal )
effectdata:SetEntity( trace.Entity )
effectdata:SetAttachment( trace.PhysicsBone )

local effectdata = EffectData()
effectdata:SetOrigin( trace.HitPos )
effectdata:SetStart( self.Owner:GetShootPos() )
effectdata:SetAttachment( 1 )
effectdata:SetEntity( self.Weapon )
util.Effect( "", effectdata )
if (SERVER) then
	local owner=self.Owner
if self.Owner.SENT then
    owner=self.Owner.SENT.Entity
end

	return true

--Bleh? This swep doesn't work if this isn't here.

end
end


function SWEP:ShootBullet( damage, num_bullets, aimcone )
	local bullet = {}
	bullet.Num 		= 4
	bullet.Src 		= self.Owner:GetShootPos()			
	bullet.Dir 		= self.Owner:GetAimVector()			
	bullet.Spread 	= Vector( aimcone, aimcone, 0.1 )		
	bullet.Tracer	= 1							 
	bullet.Force	= 500000									
	bullet.Damage	= damage
	
	bullet.AmmoType = "CombineCannon"
		bullet.Callback = function(attacker,tr,dmginfo)
			ParticleEffect("portal_2_badsurface",tr.HitPos,Angle(0,0,0),nil)
			ParticleEffect("portal_2_cleanser",tr.HitPos,Angle(0,0,0),nil)
			ParticleEffect("portal_2_close",tr.HitPos,Angle(0,0,0),nil)
			ParticleEffect("advisor_object_charge_bits",tr.HitPos,Angle(0,0,0),nil)
			end
	self.Owner:FireBullets( bullet )
	self:ShootEffects()

	
end



/*---------------------------------------------------------
   Name: SWEP:Precache()
   Desc: Use this function to precache stuff.
---------------------------------------------------------*/
function SWEP:Precache()

    	util.PrecacheSound("weapons/ScifiHandgun/shoot.wav")
end	