if ( SERVER ) then
 
    AddCSLuaFile( "shared.lua" )
 
end
 
if ( CLIENT ) then
 
  SWEP.PrintName = "Disintegrathon";
   SWEP.Slot = 1;
   SWEP.SlotPos = 1;
   SWEP.DrawAmmo = true;
   SWEP.DrawCrosshair = false;
   SWEP.Category = "Chris's SWEPs"
   SWEP.Author = "Chris";
   SWEP.Contact = "Cheesecake Servers";
   SWEP.Purpose = "";
   SWEP.Instructions = "This fine weapon has many unique features, including amazing ability to relegate your enemies to the past tense in style."
   SWEP.WepSelectIcon        = surface.GetTextureID("vgui/entities/weapon_disin")



    killicon.AddFont( "weapon_deagle", "CSKillIcons", SWEP.IconLetter, Color( 255, 80, 0, 255 ) )
     
    // Generated VElements and WElements tables go here:
   SWEP.VElements = {
	["sprite1"] = { type = "Sprite", sprite = "sprites/animglow02", bone = "v_weapon.p228_Slide", pos = Vector(0.15, -0.195, -1.188), size = { x = 0.312, y = 0.312 }, color = Color(75, 255, 66, 255), nocull = true, additive = true, vertexalpha = true, vertexcolor = true, ignorez = false},
	["some_unique_name"] = { type = "Model", model = "models/Nirrti/Disintegrathon/disintegrathon.mdl", bone = "v_weapon.p228_Parent", pos = Vector(0.263, 2.138, 2.661), angle = Angle(90, 0, 90), size = Vector(0.925, 1.044, 0.925), color = Color(255, 255, 255, 255), surpresslightning = false, material = "", skin = 0, bodygroup = {} },
	["sprite2"] = { type = "Sprite", sprite = "sprites/animglow02", bone = "v_weapon.p228_Slide", pos = Vector(0.388, -0.209, -1.188), size = { x = 0.312, y = 0.312 }, color = Color(255, 0, 0, 255), nocull = true, additive = true, vertexalpha = true, vertexcolor = true, ignorez = false}
}
  SWEP.WElements = {
	["some_unique_name"] = { type = "Model", model = "models/Nirrti/Disintegrathon/disintegrathon.mdl", pos = Vector(5.981, 1.769, -3.175), angle = Angle(-10.75, -0.106, -180), size = Vector(0.948, 0.948, 0.948), color = Color(255, 255, 255, 255), surpresslightning = false, material = "", skin = 0, bodygroup = {} }
}
end
 
// Use the same holdtype that you used for your design
SWEP.Base               = "weapon_mad_base"

SWEP.HoldType = "pistol"
SWEP.ViewModelFOV = 62
SWEP.ViewModelFlip = true
SWEP.ViewModel = "models/weapons/v_pist_p228.mdl"
SWEP.WorldModel = "models/weapons/w_pist_p228.mdl"
SWEP.ShowViewModel = true
SWEP.ShowWorldModel = false
SWEP.ViewModelBonescales = {["v_weapon.p228_Slide"] = Vector(0.009, 0.009, 0.009), ["v_weapon.p228_Clip"] = Vector(0.009, 0.009, 0.009), ["v_weapon.p228_Parent"] = Vector(0.009, 0.009, 0.009), ["v_weapon.p228_Hammer"] = Vector(0.009, 0.009, 0.009)}
SWEP.Spawnable          = false
SWEP.AdminSpawnable     = true


SWEP.Weight             = 5
SWEP.AutoSwitchTo       = false
SWEP.AutoSwitchFrom     = false
 

SWEP.Primary.Recoil		= .07
SWEP.Primary.Damage		= 75
SWEP.Primary.Ignite     = true;
SWEP.Primary.Force      = 65;
SWEP.Primary.NumShots	= 1
SWEP.Primary.Cone		= 0.0
SWEP.Primary.Delay 		= 0.12
SWEP.Primary.Automatic 	= false

SWEP.Primary.ClipSize		= 15					// Size of a clip
SWEP.Primary.DefaultClip	= 100					// Default number of bullets in a clip
SWEP.Primary.Ammo			= "ar2"
 
SWEP.Secondary.ClipSize     = -1
SWEP.Secondary.DefaultClip  = -1
SWEP.Secondary.Automatic    = false
SWEP.Secondary.Ammo         = "none"
 
// You can replace these with whatever ironsight values you generated

SWEP.IronSightsPos = Vector(5, 0, 0.56)
SWEP.IronSightsAng = Vector(0, 0, 0)


function SWEP:Deploy()
	self.Owner:EmitSound( "weapons/disin/deploy.wav" ) ;
	return true;
end

function SWEP:Reload()
	if !( ( self.Weapon:Clip1() ) < ( self.Primary.ClipSize ) ) then return end
	self.Weapon:DefaultReload( ACT_VM_RELOAD )
	self:EmitSound( "weapons/disin/reload3.wav" )
end


  
function SWEP:PrimaryAttack()
	// Make sure we can shoot first
	if ( !self:CanPrimaryAttack() ) then return end

	self.Weapon:EmitSound(Sound("weapons/disin/pew.wav"))
    self.Weapon:EmitSound(Sound("weapons/disin/pew2.wav"))

	self:ShootBullet( 100, 1, 0 )

	// Remove 1 bullet from our clip
	self:TakePrimaryAmmo( 1 )

		local vShootPos = self.Owner:GetShootPos()
		local vShootAng = self.Owner:GetAimVector()
		
		local t = {}		

		t.caller  	= self.Owner	
		t.start   	= vShootPos	
		t.sang	 	= vShootAng	
		t.mreps	 	= 100		
		t.reps   	= 0 
		t.damage 	= 140
		t.length 	= 70
		t.filter 	= self.Owner		
		t.maxpens 	= 20
		t.pens	  	= 0
		t.powdeg  	= .01
		t.skew	  	= Vector( .05, .05, .05 )
		t.canbounce	= true
		t.bounceang	= .3
		t.bouncechance	= .4

	// Punch the player's view
	self.Owner:ViewPunch( Angle( -1, 0, 0 ) )
	self.Weapon:SetNextPrimaryFire( CurTime() + 2 )
	self:EmitSound( "weapons/disin/charge.wav" )
	

	local trace = self.Owner:GetEyeTrace()
local effectdata = EffectData()
effectdata:SetOrigin( trace.HitPos )
effectdata:SetNormal( trace.HitNormal )
effectdata:SetEntity( trace.Entity )
effectdata:SetAttachment( trace.PhysicsBone )

local effectdata = EffectData()
effectdata:SetOrigin( trace.HitPos )
effectdata:SetStart( self.Owner:GetShootPos() )
effectdata:SetAttachment( 1 )
effectdata:SetEntity( self.Weapon )
util.Effect( "", effectdata )
if (SERVER) then
	local owner=self.Owner
if self.Owner.SENT then
    owner=self.Owner.SENT.Entity
end

	return true

--Bleh? This swep doesn't work if this isn't here.

end
end

function SWEP:ShootBullet( damage, num_bullets, aimcone )
	local bullet = {}
	bullet.Num 		= 1
	bullet.Src 		= self.Owner:GetShootPos()			
	bullet.Dir 		= self.Owner:GetAimVector()			
	bullet.Spread 	= Vector( 0, 0, 0 )		
    bullet.Tracer 	= 1       									-- Show a tracer on every x bullets
	bullet.TracerName 	= "laser"				
	bullet.Force	= 5000									
	bullet.Damage	= damage
	bullet.AmmoType = "AR2AltFire"
		bullet.Callback = function(attacker,tr,dmginfo)
			ParticleEffect("portal_1_badvolume",tr.HitPos,Angle(0,0,0),nil)
			ParticleEffect("portal_1_charge",tr.HitPos,Angle(0,0,0),nil)
			ParticleEffect("portal_1_charge",tr.HitPos,Angle(0,0,0),nil)
			ParticleEffect("portal_2_badvolume",tr.HitPos,Angle(0,0,0),nil)
		    ParticleEffect("portal_2_badsurface",tr.HitPos,Angle(0,0,0),nil)
			end

		
					
	self.Owner:FireBullets( bullet )
	self:ShootEffects()
	
end 

function SWEP:Initialize()
 
    // other initialize code goes here
 self:SetWeaponHoldType( self.HoldType )
    if CLIENT then
     
        self:CreateModels(self.VElements) // create viewmodels
        self:CreateModels(self.WElements) // create worldmodels
         
        // init view model bone build function
        self.BuildViewModelBones = function( s )
            if LocalPlayer():GetActiveWeapon() == self and self.ViewModelBonescales then
                for k, v in pairs( self.ViewModelBonescales ) do
                    local bone = s:LookupBone(k)
                    if (!bone) then continue end
                    local m = s:GetBoneMatrix(bone)
                    if (!m) then continue end
                    m:Scale(v)
                    s:SetBoneMatrix(bone, m)
                end
            end
        end
         
    end
 
end
 
 
function SWEP:OnRemove()
     
    // other onremove code goes here
     
    if CLIENT then
        self:RemoveModels()
    end
     
end
     
 
if CLIENT then
 
    SWEP.vRenderOrder = nil
    function SWEP:ViewModelDrawn()
         
        local vm = self.Owner:GetViewModel()
        if !ValidEntity(vm) then return end
         
        if (!self.VElements) then return end
         
        if vm.BuildBonePositions ~= self.BuildViewModelBones then
            vm.BuildBonePositions = self.BuildViewModelBones
        end
 
        if (self.ShowViewModel == nil or self.ShowViewModel) then
            vm:SetColor(255,255,255,255)
        else
            // we set the alpha to 1 instead of 0 because else ViewModelDrawn stops being called
            vm:SetColor(255,255,255,1)
        end
         
        if (!self.vRenderOrder) then
             
            // we build a render order because sprites need to be drawn after models
            self.vRenderOrder = {}
 
            for k, v in pairs( self.VElements ) do
                if (v.type == "Model") then
                    table.insert(self.vRenderOrder, 1, k)
                elseif (v.type == "Sprite") then
                    table.insert(self.vRenderOrder, k)
                end
            end
             
        end
 
        for k, name in ipairs( self.vRenderOrder ) do
         
            local v = self.VElements[name]
            if (!v) then self.vRenderOrder = nil break end
         
            local model = v.modelEnt
            local sprite = v.spriteMaterial
             
            if (!v.bone) then continue end
            local bone = vm:LookupBone(v.bone)
            if (!bone) then continue end
             
            local pos, ang = Vector(0,0,0), Angle(0,0,0)
            local m = vm:GetBoneMatrix(bone)
            if (m) then
                pos, ang = m:GetTranslation(), m:GetAngle()
            end
             
            if (self.ViewModelFlip) then
                ang.r = -ang.r // Fixes mirrored models
            end
             
            if (v.type == "Model" and ValidEntity(model)) then
 
                model:SetPos(pos + ang:Forward() * v.pos.x + ang:Right() * v.pos.y + ang:Up() * v.pos.z )
                ang:RotateAroundAxis(ang:Up(), v.angle.y)
                ang:RotateAroundAxis(ang:Right(), v.angle.p)
                ang:RotateAroundAxis(ang:Forward(), v.angle.r)
 
                model:SetAngles(ang)
                model:SetModelScale(v.size)
                 
                if (v.material == "") then
                    model:SetMaterial("")
                elseif (model:GetMaterial() != v.material) then
                    model:SetMaterial( v.material )
                end
                 
                if (v.skin and v.skin != model:GetSkin()) then
                    model:SetSkin(v.skin)
                end
                 
                if (v.bodygroup) then
                    for k, v in pairs( v.bodygroup ) do
                        if (model:GetBodygroup(k) != v) then
                            model:SetBodygroup(k, v)
                        end
                    end
                end
                 
                if (v.surpresslightning) then
                    render.SuppressEngineLighting(true)
                end
                 
                render.SetColorModulation(v.color.r/255, v.color.g/255, v.color.b/255)
                render.SetBlend(v.color.a/255)
                model:DrawModel()
                render.SetBlend(1)
                render.SetColorModulation(1, 1, 1)
                 
                if (v.surpresslightning) then
                    render.SuppressEngineLighting(false)
                end
                 
            elseif (v.type == "Sprite" and sprite) then
                 
                local drawpos = pos + ang:Forward() * v.pos.x + ang:Right() * v.pos.y + ang:Up() * v.pos.z
                render.SetMaterial(sprite)
                render.DrawSprite(drawpos, v.size.x, v.size.y, v.color)
                 
            end
             
        end
         
    end
 
    SWEP.wRenderOrder = nil
    function SWEP:DrawWorldModel()
         
        if (self.ShowWorldModel == nil or self.ShowWorldModel) then
            self:DrawModel()
        end
         
        if (!self.WElements) then return end
         
        if (!self.wRenderOrder) then
 
            self.wRenderOrder = {}
 
            for k, v in pairs( self.WElements ) do
                if (v.type == "Model") then
                    table.insert(self.wRenderOrder, 1, k)
                elseif (v.type == "Sprite") then
                    table.insert(self.wRenderOrder, k)
                end
            end
 
        end
         
        local opos, oang = self:GetPos(), self:GetAngles()
        local bone_ent
 
        if (ValidEntity(self.Owner)) then
            bone_ent = self.Owner
        else
            // when the weapon is dropped
            bone_ent = self
        end
         
        local bone = bone_ent:LookupBone("ValveBiped.Bip01_R_Hand")
        if (bone) then
            local m = bone_ent:GetBoneMatrix(bone)
            if (m) then
                opos, oang = m:GetTranslation(), m:GetAngle()
            end
        end
         
        for k, name in pairs( self.wRenderOrder ) do
         
            local v = self.WElements[name]
            if (!v) then self.wRenderOrder = nil break end
         
            local model = v.modelEnt
            local sprite = v.spriteMaterial
 
            local pos, ang = Vector(opos.x, opos.y, opos.z), Angle(oang.p, oang.y, oang.r)
 
            if (v.type == "Model" and ValidEntity(model)) then
 
                model:SetPos(pos + ang:Forward() * v.pos.x + ang:Right() * v.pos.y + ang:Up() * v.pos.z )
                ang:RotateAroundAxis(ang:Up(), v.angle.y)
                ang:RotateAroundAxis(ang:Right(), v.angle.p)
                ang:RotateAroundAxis(ang:Forward(), v.angle.r)
 
                model:SetAngles(ang)
                model:SetModelScale(v.size)
                 
                if (v.material == "") then
                    model:SetMaterial("")
                elseif (model:GetMaterial() != v.material) then
                    model:SetMaterial( v.material )
                end
                 
                if (v.skin and v.skin != model:GetSkin()) then
                    model:SetSkin(v.skin)
                end
                 
                if (v.bodygroup) then
                    for k, v in pairs( v.bodygroup ) do
                        if (model:GetBodygroup(k) != v) then
                            model:SetBodygroup(k, v)
                        end
                    end
                end
                 
                if (v.surpresslightning) then
                    render.SuppressEngineLighting(true)
                end
                 
                render.SetColorModulation(v.color.r/255, v.color.g/255, v.color.b/255)
                render.SetBlend(v.color.a/255)
                model:DrawModel()
                render.SetBlend(1)
                render.SetColorModulation(1, 1, 1)
                 
                if (v.surpresslightning) then
                    render.SuppressEngineLighting(false)
                end
                 
            elseif (v.type == "Sprite" and sprite) then
                 
                local drawpos = pos + ang:Forward() * v.pos.x + ang:Right() * v.pos.y + ang:Up() * v.pos.z
                render.SetMaterial(sprite)
                render.DrawSprite(drawpos, v.size.x, v.size.y, v.color)
                 
            end
             
        end
         
    end
 
    function SWEP:CreateModels( tab )
 
        if (!tab) then return end
 
        // Create the clientside models here because Garry says we can't do it in the render hook
        for k, v in pairs( tab ) do
            if (v.type == "Model" and v.model and v.model != "" and (!ValidEntity(v.modelEnt) or v.createdModel != v.model) and
                    string.find(v.model, ".mdl") and file.Exists ("../"..v.model) ) then
                 
                v.modelEnt = ClientsideModel(v.model, RENDER_GROUP_VIEW_MODEL_OPAQUE)
                if (ValidEntity(v.modelEnt)) then
                    v.modelEnt:SetPos(self:GetPos())
                    v.modelEnt:SetAngles(self:GetAngles())
                    v.modelEnt:SetParent(self)
                    v.modelEnt:SetNoDraw(true)
                    v.createdModel = v.model
                else
                    v.modelEnt = nil
                end
                 
            elseif (v.type == "Sprite" and v.sprite and v.sprite != "" and (!v.spriteMaterial or v.createdSprite != v.sprite)
                and file.Exists ("../materials/"..v.sprite..".vmt")) then
                 
                local name = v.sprite.."-"
                local params = { ["$basetexture"] = v.sprite }
                // make sure we create a unique name based on the selected options
                local tocheck = { "nocull", "additive", "vertexalpha", "vertexcolor", "ignorez" }
                for i, j in pairs( tocheck ) do
                    if (v[j]) then
                        params["$"..j] = 1
                        name = name.."1"
                    else
                        name = name.."0"
                    end
                end
 
                v.createdSprite = v.sprite
                v.spriteMaterial = CreateMaterial(name,"UnlitGeneric",params)
                 
            end
        end
         
    end
 
    function SWEP:RemoveModels()
        if (self.VElements) then
            for k, v in pairs( self.VElements ) do
                if (ValidEntity( v.modelEnt )) then v.modelEnt:Remove() end
            end
        end
        if (self.WElements) then
            for k, v in pairs( self.WElements ) do
                if (ValidEntity( v.modelEnt )) then v.modelEnt:Remove() end
            end
        end
        self.VElements = nil
        self.WElements = nil
    end
 
end